/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Autor file

#ifndef __CAUTOR_H
#define __CAUTOR_H

#include "btree.h"

class Autor : public BTree {
public:
	void	Export (Cbyte &fname);
	int m_seekstart;
	int RebuildAutor (int lang);
	int SynthesizeForm (byte *ptr, Cbyte &in, Cbyte &out);
	int GetQuestion (int num, Cbyte &whereto);
	int GetCondition (byte *ptr, Cbyte &wword);
	int FindAutorLine (Cbyte &wword, int lgk, int type);
	int FindAnyAutorLine (Cbyte &wword, int lgk, int type);
	int OpenAutor (int lang, Cbyte &datapath = data.m_datapath);
	int GetLgk();
	int CreateAutorSourceFromSik();

	int ParseLine (Cbyte &wword, Cbyte &questions, 
	Cbyte &forms, Cbyte &needvalue, Cbyte &lgkmask, 
	int *classn, int *lgk, Cbyte &stem);
   Autor();
   ~Autor();

	int m_wasfind;
};

extern Autor *GetAutorPointer (int lang, Cbyte &datapath = data.m_datapath);
#endif   // __CAUTOR
