/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Class used to copy files
#ifndef __CCOPYFILE_H     /* prevent multiple includes */
#define __CCOPYFILE_H

class CCopyFile {
public:
   ~CCopyFile();
	CCopyFile (Cbyte &from, Cbyte &to);
	CCopyFile ();
   CCopyFile (Cbyte &inpath, Cbyte &infilename, Cbyte &outpath, Cbyte &outfilename);
	void AssignFileNames (const Cbyte &inpath, const Cbyte &infilename, const Cbyte &outpath, const Cbyte &outfilename);
	long	ReallocateBuffer();
   long	DoCopy();
	int	CopyFile (Cbyte &from, Cbyte &to);
	int	CopyWholeFile ();
	void	CloseAll();

	DWORD m_LastWriteTime;
	int	m_CopyFileTime;
	Cbyte m_inname;
	Cbyte m_indir;
	Cbyte m_outname;
	Cbyte m_outdir;
   int	m_inhand;
   int	m_outhand;
	int	m_delta;
   long	m_totalsize;
   Cbyte	m_copybuff;
   long	m_buffsize;
	long	m_wasread;
	long	m_waswritten;
	int	m_DisplayWarnings;
	int	m_StartBufferSize;
	int	m_OkBufferSize;
	long	m_curwritten;
	int m_Error;
};
#endif
