/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Translation dictionary class

#ifndef __CDICT_H     /* prevent multiple includes */
#define __CDICT_H

#include "btree.h"
#include "getbit.h"
#include "noclass.h"

#if 0
class Edic : public BTree {
 public:
  Edic ();

  void	ReBuild();
};
#endif


class Dict : public BTree {
 public:
  Dict ();
  ~Dict();

  void	Export ();
  int	SeekWordNumber (long wordnum, int checkinclusion = 0);
  int	OpenDict (int langin, int langout, Cbyte datapath = (Cbyte)"");
  int	CloseDict();
  long	WriteEntry (Cbyte &trabuff1, long termnum);
  int	DeleteTraEntry (long termnum);
  long	GetTermNumber ();
  int	SeekTermNumber (long termnum);
  long	CollectAccessibleTermNumbers();
  long	CollectSubjectNumbers();
  int	CopyReferencedTermNumbers (OperateBit *bitptr, Cbyte &path);
  int	FindUnknownSubjects ();
  const void FormDictExtension (Cbyte &buff);
  void	FindEmptyMainFields ();
  void	FindNonLetterSymbols ();
  int GetMemorySubject (long termnum) {
    return (m_SubjectNumberBuffer[termnum]); 
  }
  static const void ReOpenDatabases (int justclose = 0);

  int	m_EntryPortions; // = 2 if entry is split to 2 database records
  int	m_delete_before_append;
  OperateBit m_BitArray;

  // For collecting subject numbers for aech entry
  Cbyte	m_SubjectNumberFileName;
  int	m_SubjectNumberHandle;
  __int16	*m_SubjectNumberBuffer;
};

extern Dict *GetDictPointer (int langin, int langout, Cbyte &datapath = data.m_datapath);

#define MAXDICTS 5 // currently only one translation dictionary is needed + one for synonims
//extern Dict Dicts[MAXDICTS];

#endif  // __CDICT
