/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef __GETBIT_H     /* prevent multiple includes */
#define __GETBIT_H

#include "cbyte.h"

// Class to operate bit strings used for quick setting/checking of flags
class OperateBit
{
public:
   OperateBit ();
   OperateBit (DWORD size, unsigned char *buff = NULL);
	OperateBit (DWORD max, int fillsymbol);
   ~OperateBit ();

	int	AssignArray (byte *arrptr, long maxbytes);
	void Clear(void) {InitBit (m_MaxSize);};
	int WriteToFile (byte *fname);
	int ReadFromFile (byte *fname);

	byte *GetBitString ();
   int SetMaxRange (DWORD val, int setvalue = 0);
   DWORD GetMaxRange () const {return (m_MaxSize);};
   int	InitBit (DWORD val, int setvalue = 0);
//   inline void	SetBit (DWORD val);
// set bit value to 1 at specified offset in buffer
inline void OperateBit::SetBit (DWORD l)
{
   if (l < m_MaxSize) // value inside of string
	   m_BitString[l >> 3] |= numbers[l & 7];
}

//   inline int	GetBit (DWORD val);
// get bit value
inline int OperateBit::GetBit (DWORD l)
{
   if (l < m_MaxSize)
	   return (m_BitString [l >> 3] & numbers [l & 7]);
	else
		return 0;
}

   int	ResetBit (DWORD val);
   int	Release ();
	DWORD GetMaxRange ();
   unsigned char *m_BitString;
   DWORD m_MaxSize;

private:
static unsigned char numbers[8];
};

#endif // __GETBIT
