/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Network operation - login and logout

#ifndef __MTNET_H     /* prevent multiple includes */
#define __MTNET_H

#include "btree.h"

class CMtNet : public BTree
{
public:
   CMtNet();
   ~CMtNet();

	int	LoadUser (byte *UserName);
	int	UnloadUser (byte *UserName);
	int	GetLastUpdateTime (byte *buff);
   int	CreateLog (int max);
   int	OpenLog ();
   int	DestroyLocalMt();
	int	CountActiveUsers (byte *UserName);
	int	UpdateUser (byte *UserName);
	int	IsActiveUser (void);
	int	GetMaxUsers();
	void  SetMaxUsers (int maxusers);
};

#define TIME_INT 60
#define TIME_INTERVAL1 60
#define MAX_USERS 3

#define NET_NO_SUCH_USER -1
#define NET_NO_LOG_FILE  -2
#define NET_DESTROYED     5

#endif
