/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Declarations of functions not included in any class
#ifndef __NOCLASS_H     /* prevent multiple includes */
#define __NOCLASS_H
#include "cbyte.h"

#ifdef UNIX
#include <iconv.h>
#endif

#define	I_DAY		1
#define	I_MONTH	2
#define	I_YEAR	4
#define	I_HOUR	8
#define	I_MINUTE	16
#define	I_SECOND	32
extern void ExtractDateInformation (Cbyte &ttime, int param);
extern int TempName (Cbyte &path1, Cbyte &result);
extern int MoveFiles (Cbyte &from, Cbyte &to1);
extern void SetDosText (int val);
extern int GetDosText ();

extern int ExtractGlobalSubject (Cbyte &buff);
extern void ReverseString (byte *buff, int size);
extern long IncrementCounterInTextFile (Cbyte &name, int value = -1);

extern void GetFileTime (Cbyte &fname, Cbyte &ftime);
extern void EraseHtmlTags (Cbyte &buff);
extern void WebDebug (byte *b, byte *b1 = NULL);
#define MULTITRAN_EMAIL "pom@aha.ru"

#ifdef WIN32
extern void AddToHistory (Cbyte &param, Cbyte &fname = (Cbyte)"");
#else 
extern void AddToHistory (Cbyte &param, Cbyte fname = (Cbyte)"");
#endif

extern byte *GetStatisticsName (byte *fname);
extern int GetInputParameter (byte *param, Cbyte &value);
extern void SetDebug (int val);
extern int GetDebug ();

extern int IsDate1BiggerThanDate2 (Cbyte &date1, Cbyte &date2);
extern BOOL DeleteProgramGroup (Cbyte &lpszGroupName);
extern BOOL DeleteDesktopLink (Cbyte &buff);

#ifdef WIN32
extern void CreateUninstallFileList();
#endif

extern long GetFileSize (FILE *hand);
extern long GetFileSize (Cbyte &path);
extern long GetFileSize (int hand);
extern void ConvertToEnglish (Cbyte &buff);
extern int FirstFileIsNewerThanSecond (Cbyte &fname1, Cbyte &fname2);
//#define MT_DOWNLOAD 1 // internet donwloadable version doesn't use net and is not demo

extern int FillDayMonthYear (Cbyte &date, int *day1 = NULL, int *month1 = NULL, int *year1 = NULL);

// for cphrase
#define MAXNOPHRASE 10 // used for splitting phrases
struct NoPhrase {
	int start;
	int end;
	};
// Screen elements structure
struct positions
{
	int	line;
	int	offset;
	int	type;
	int	size;
	int	TB_number;
	Cbyte buff;
	int	color;
};

class HideBrackets
{
public:
	HideBrackets (Cbyte &buff);
	int	GetBrackets (int pos, Cbyte &buff);
	char	HideBrackets::GetBracketType (int pos);
	void	UnHide (Cbyte &buff);

	Cbyte m_save[256];
	int	m_max;
};

extern int  g_inappend;

extern int	ClipboardImport (Cbyte &buff);
#define ENGLISH_RUSSIAN 1
#define ONLY_RUSSIAN		2
#define ONLY_GERMAN		3
#define GERMAN_RUSSIAN	4
#define ONLY_ENGLISH		5

#define EXTRACT_ANY_BRACKETS 1

extern void ConvertStringForMail (Cbyte &buff);

#ifdef WIN32
extern int DeleteAllFilesByTemplate (Cbyte &copyto, Cbyte &flist);
extern int DeleteFilesByTemplate (Cbyte &copyto, Cbyte &copyfrom);
#endif

extern int IsWorkingWithLanguages (int lang1, int lang2 = 0);
extern void	ExtractBrackets (Cbyte &from, Cbyte &where, int anywhere = 0);
extern int IsDigit (byte c);
extern int IsDigit (Cbyte buff);

#ifdef WIN32
extern int IsUserCtrlShiftBreak();

#endif

#define UMLAUT_REPLACEMENT_SINGLE		1
#define UMLAUT_REPLACEMENT_AMPERSANT	4
#define UMLAUT_REPLACEMENT_DOUBLE		8
extern void UmlautToEnglishReplacements (Cbyte &buff, int type = UMLAUT_REPLACEMENT_DOUBLE);

extern void SetWindowNameWithLanguages();
extern void SetWindowName (Cbyte &buff);
extern void SetWorkingLanguages (int langin, int langout);
extern int DetermineLanguage (Cbyte &buff, int type = 0);
extern int DetermineOutputLanguage (Cbyte &buff);
extern int GetWorkingLanguage (int type);
extern void ReverseWorkingLanguages();
extern unsigned long ConvertDateTimeToSeconds (Cbyte &buff);
extern unsigned long ConvertTimeToSeconds (Cbyte &buff);
extern byte *GetFileName (int type, int langin, int langout = -1, Cbyte datapath = "");
extern void SetDatabaseType (int type);
extern int GetDatabaseType ();
extern void ConvertFromInternetCodetable (Cbyte &searchbuff);
extern int IsHexadecimal (int val);
#ifdef UNIX
extern int SetLastError ( int val );
extern void strrev(char *str);
extern int apply_iconv(iconv_t cd, char *buffer, size_t len, char **buffer_r,
		      size_t *len_r, size_t *error_pos_r);
extern int GetGlobalParametersUNIX (byte *fname);
#endif


#define TYPE_DICTIONARY				1
#define TYPE_INDEX					2
#define TYPE_TYPEIN					3
#define TYPE_PHRASES					4
#define TYPE_ABC_LIST				5
#define TYPE_STEM						6
#define TYPE_WORDS					7
#define TYPE_SUBJECT_STATISTICS	8
//#define TYPE_FIND_LETTERS			9
#define TYPE_SYNTHESIZED_ABBREVIATION 10
#define TYPE_AUTOR_SOURCE					11
#define TYPE_ABC								12
#define TYPE_AUTOR							13
#define TYPE_SIK_SOURCE						14
#define TYPE_END_NUMBER						15
#define TYPE_END								16
#define TYPE_SIK_TABLE						17
#define TYPE_PREFIXES_FOR_WORD			18
#define TYPE_WORDS_FOR_PREFIX				19
#define TYPE_SAME_SIK						20
#define TYPE_PRONONCIATION					21
#define TYPE_PREFIX							22
#define TYPE_ENCYCLOPAEDIC_DICTIONARY	23
#define TYPE_NUMBER_WORD					24
#define TYPE_WORD_FREQUENCY				25
#define TYPE_STORE_FIND_LETTERS			26
#define TYPE_FIND_LETTERS					27
#define TYPE_USERTRA							28
#define TYPE_PREFIXES_FOR_LANGUAGE		29
#define TYPE_PUNTO_TEXT_NAME				30
#define TYPE_PUNTO_STORE_TEXT_INDEX		31
#define TYPE_WWW_GLOSSARY_DICTIONARY	32
#define TYPE_CODE_TO_FILE_NAME			33
#define TYPE_FILE_NAME_TO_CODE			34
#define TYPE_WORD_NUMBER_TO_TEXT_NUMBER 35
#define TYPE_SYNONIM							36
#define TYPE_BACK_WORDS						37
#define TYPE_SUBJECT_LIST					38
#define TYPE_WEB_PHRASE						39
#define TYPE_ACADEMIC_DICTIONARY			40
#define TYPE_NOUN_GENDER					41

#define	DATABASE_TRANSLATION_DICTIONARY	1
#define	DATABASE_COMBINATORY_DICTIONARY	2
#define	DATABASE_EUPHEMISM_DICTIONARY		4
#define	DATABASE_WEBINDEX_DICTIONARY		8

extern void ConvertStringToSearchableString (Cbyte &inbuff, Cbyte &outbuff1);
#define CURRENT_WORD_MACRO_VERSION 2

#define VIEWER_PROP_NAME "ViewersMainWnd"
#define MULTITRAN_PROP_NAME "MultitranMainWnd1" // new version

// Multitran Setup
#define VERSION_NUMBER 318 // change of this value forces reset of toolbars and some options for all users
#define UNINSTALL_INFO_FILE "uninst.inf"
extern void AddToInstalledFileList (Cbyte &buff);
extern void DeleteInstalledFileList ();
extern int	DeleteInstalledFiles (Cbyte ignorelist = (Cbyte) "");
extern void RecursiveDeleteDirectory (Cbyte &buff);
extern void ZapDirectory (Cbyte &buff, int all = 0);
#define TIME_GET_TIME		1
#define TIME_GET_DATE		2
#define TIME_GET_SECONDS	4
extern void GetTimeAsString (Cbyte &buff, int param = TIME_GET_TIME | TIME_GET_DATE | TIME_GET_SECONDS);
extern int CheckExistInstalledFileList();

// Registry constants
#define DATA_PATH							"DataPath"
#define LOCAL_PATH						"LocalPath"
#define TRIAL_VERSION					"TrialVersion"
#define DEMO_WEEKS						"DemoWeeks"
#define SINGLE_VIEWER					"SingleViewer"
#define DEFAULT_HELP_LANGUAGE			"DefaultHelpLanguage"
#define TRANSCRIPTION_FONT_INSTALLED "TranscriptionFontInstalled"
#define EDIT_ENTRIES						"AllowEditEntries"
#define DELETE_ENTRIES					"AllowDeleteEntries"
#define APPEND_ENTRIES					"AllowAppendEntries"
#define MOVE_ENTRIES						"AllowMoveEntries"
#define ACTION_DELETE					"ActionDelete"
#define ACTION_INSERT					"ActionInsert"
#define ACTION_DOUBLE_CLICK			"ActionDoubleClick"
#define ACTION_ENTER						"ActionEnter"
#define ACTION_TAB						"ActionTab"
#define TRANSLATE_FROM_CLIPBOARD		"TranslateFromClipboard"
#define WARN_LARGE_CLIPBOARD			"WarnLargeClipboard"
#define CLIPBOARD_PROCESS_SIZE		"ClipboardProcessSize"
#define AUTO_PROCESS_CLIPBOARD		"AutoProcessClipboard"
#define AUTOMATIC_TRANSLITERATION	"AutomaticTransliteration"
#define EXTERNAL_DICTIONARY_PATH		"ExternalDictionaryPath"
#define USE_MULTITRAN_DIALOG_FONT	"UseMultitranDialogFont"
#define WRITE_SCRIPT_FILE				"WriteScriptFile"
#define MULTIDISPLAY_SUPPORT			"MultiDisplaySupport"
#define SUBJECT_LINE_BREAK				"SubjectLineBreak"
#define SHOW_INCLUSIONS					"ShowInclusions"
#define SHOW_COMMENTS					"ShowComments"
#define AUTOMATIC_TYPEIN				"AutomaticTypeIn"
#define CHECK_SUBJECTS					"CheckSubjects"
#define CLIPBOARD_PROCESS_SIZE		"ClipboardProcessSize"
#define DEFAULT_APPEND_SUBJECT		"DefaultAppendSubject"
#define ENTER_ACTION						"EnterAction"
#define MULTITRAN_VERSION				"VersionNumber"
#define DEFAULT_APPEND_SUBJECT_CODE	"DefaultAppendSubject"
#define TIP_OF_THE_DAY					"TipOfTheDay"
#define TIP_OF_THE_DAY_COUNT			"TipOfTheDayCount"
#define DISPLAY_TYPEIN_TRANSLATIONS "DisplayTypeinTranslations"
#define ACTIVATE_ON_CTRL_INS_INS		"ActivateOnCtrlInsIns"
#define VIEWER_HEADER_LANGUAGE		"ViewerHeaderLanguage"
#define DUMP_NEW_STEMS					"DumpNewStems"
#define MIN_PHRASE_SIZE					"MinPhraseSize"
#define CHECK_WORD_CASE					"CheckWordCase"
#define DEFAULT_TAB_ACTION				"DefaultTabAction"
#define WORD_MACRO						"WordMacro"
#define SEARCH_WHAT_IS_TYPED_IN		"SearchWhatIsTypedIn"
#define LOCAL_DIRECTORY					"LocalDirectory"
#define SUGGEST_LEVEL					"SuggestLevel"
#define PAGE_DOWN_ACTION				"PageDownAction"
#define SUGGEST_TYPE						"SuggestType"
#define LANG_IN							"InputLanguage"
#define LANG_OUT							"OutputLanguage"
#define AUTO_APPEND_ABBREVIATIONS	"AutoAppendAbbreviations"
#define SORT_SUBJECTS_BY_NUMBER_OF_TRANSLATIONS "SortSubjectsByNumberOfTranslations"
#define MULTITRAN_EXE_NAME				"MultitranExeName"
#define STEM_PATH							"StemPath"
#define COPY_TO_CLIPBOARD_UMLAUTS_AS_ENGLISH "CopyToClipboardUmlautsAsEnglish"
#define DEFAULT_DICTIONARY				"DefaultDictionary"
#define MT_NET								"MtNet"
#define DATA_PATH                                       "DataPath"

////////////////////////////////////////////////////////////
// MS Word support
extern	int	InstallWordMacro (byte *AppName = NULL);
extern	void	WordInstalledMessage (int type);

// Check for demo time
extern   int   CheckVersionTime();

extern	void	GetLoadPath (Cbyte &buff);

// Database network locking functions
//extern 	CTime SaveLastSystemUpdate;  // Last update time of SCRIPT.TXT
extern	void	ReOpenDatabases (int justclose = 1);
extern	void	CloseAllDatabases ();
extern	void	UnlockDatabases (int waschange = 1);
extern	int	LockDatabases();
extern	int	PerformSystemUpdate();
extern	void	SaveSystemUpdate();

// Registry functions
extern	void	WriteRegistryData();
extern	void	ReadRegistryData ();

// Check for developer environment
extern	int	CheckDeveloper();
extern	int	GetDeveloper ();
extern	void	SetDeveloper (int val);

extern	void	TraceMessage (byte *mess1 = NULL, byte *mess2 = NULL);

#ifndef WIN32
#define MB_OK 0
#define IDOK 0
#endif

extern	int	MyMessageBox (int messnum, UINT nType = MB_OK, UINT nIDHelp = 0);
extern	int	MyMessageBox (Cbyte &mess, UINT nType = IDOK);
extern	int	MyMessageBox (byte *mess, int type = IDOK);
//extern	int	MyMessageBox (byte *mess, UINT nType = MB_OK, UINT nIDHelp = 0);
extern	void	MyMessageBox (byte *one, Cbyte &two);
extern	void	MyMessageBox (Cbyte &one, byte *two);
extern	void	MyMessageBox (Cbyte &one, Cbyte &two);
extern	void	MyMessageBox (byte *one, byte *two);
extern	void	GetLogPath (Cbyte &path);
extern	void	SetLogPath (LPCTSTR path);
extern	int	OpenSubjectView (int snum, int langin, int langout, char *wword = "");
#define PARAMETER_DELIMITER "\x1" // it is used !
#define PARAMETER_DELIMITER_SINGLE "\x1"
extern	int	PutParameterToFile (Cbyte &wword);
extern	int	GetParameterFromFile (Cbyte &wword, int dodelete = 1);
extern	void UnlinkParameterFile ();

#ifdef WIN32
extern	int RunModule (byte *exename, byte *parameters = "", int strictname = 0, HANDLE *hProcessPtr = NULL);
#endif

extern	int ExecuteModule (byte *exename, byte *param);
extern	void ExecuteMultiedit (byte *param);
extern	void WriteEnvironmentToFile();

extern	long ReverseLong (long &l); // Returns a pointer to reversed string value of long
extern	long GetLongFromReverseLong (byte *lptr);

// Types of screen elements - must be the same as in VIEWPROC.H !!!
#define MAX_FONT_TYPES					14 // max number of following types:
#define TYPE_ORIGINAL					0
#define TYPE_SPEECH						1
#define TYPE_TRANSLATION				2
#define TYPE_SUBJECT						3
#define TYPE_COMMENT						4
#define TYPE_NEXTLINE					5
#define TYPE_COMMA						6
#define TYPE_BULLET						7
#define TYPE_TRANSCRIPTION				8
#define TYPE_DIALOGUE					9
#define TYPE_TIP_OF_THE_DAY			10
#define TYPE_TIP_OF_THE_DAY_CHECK	11
#define TYPE_PICTURE						12
#define TYPE_GERMAN						13
#define TYPE_ANY							14

#define TYPE_OLE							12

#ifdef WIN32
//#ifndef _NO_WINDOWS_INTERFACE
extern CFont m_Fonts[/*MAX_FONT_TYPES*/]; // System fonts
extern LOGFONT m_FontType[MAX_FONT_TYPES];
//#endif
#endif

#define VERTICALDELTA 2 // used by GetVerticalDelta
struct FontColor {
	int x;
	int y;
	int z;
	};
extern struct FontColor BkColor[MAX_FONT_TYPES];
extern struct FontColor TextColor[MAX_FONT_TYPES]; 

#define HIDE_TRANSLATION 1  // type of showing specified translation
#define SHOW_TRANSLATION 2
#define RED_TRANSLATION  3

#define VIEWER_HEADER 846 // number of message "Multitrans Viewer"
#define NO_DEFAULT_MESSAGE ""

extern byte *GetShortEnglishLanguageName (int num);  /* returns 3-letter language name in English */
extern byte *GetEnglishLanguageName (int num);  /* returns language name in English */
extern byte *GetFirstLetterOfEnglishLanguageName (int lang);
extern int ReadMultitranRegistrySection();
extern int IsKeyPressed (int key);

extern BOOL CloseViewer (int snum);
extern void CloseViewers ();

extern void CopyToClipboard (char * out, int lang = 1);
extern void CheckClipboard (Cbyte &processbuff1, int defaultcodepage = 0);
extern int GetGlobalParameters (byte *fname);
extern Cbyte GetGlobalParameter (byte *fname, byte *ParameterName);
extern int WriteError (byte *filename, int error = 0);
extern int CheckUnload (int saymess = 0);
extern int IsValidLanguage (int lang);
extern int CheckDeleteArtextRegistrySection();

#define UNLOAD_TIMER_CHECK_TIME 30*1000 ///30 sec * 1000 milisec - 10 minutes interval to check for "unload" file (to automatically unload MT on the network)

class Cfile
{
public:
	int	OpenFile (byte *dir, byte *fname, byte *flags);
	Cfile (Cbyte &dir, byte *fname, byte *flags);
	Cfile (Cbyte &dir, Cbyte &fname, byte *flags);
	Cfile (byte *fname = NULL, byte *flags = NULL);
	Cfile (byte *dir, byte *fname, byte *flags);
	Cfile (Cbyte &fname, byte *flags);
	~Cfile ();
	void	CloseFile ();
	int	Fopen (byte *fname, byte *flags);
	int   Fgets (byte *buff, int max);
	int	Fgets (Cbyte &buff);
	int	Fputs (byte *buff, byte *buff1 = NULL);
	int	Fputs (Cbyte &buff, byte *buff1 = NULL) {return Fputs (buff.b, buff1);};
	int	Fseek (long offset, int origin);	
	int	IsOpen ();
	int	Unlink();
	int	Fclose ();
	int	Fflush();
	Cbyte m_fname;

	FILE *m_hand;
	int	m_ConvertToDos;
	int	m_OpenBeforeWrite;
private:
};

extern int CanWriteToDirectory (Cbyte &buff);
extern int CheckFileExists (Cbyte path, Cbyte fname = (Cbyte)"");
extern int CheckDirectoryExists (byte *path, byte *fname = NULL);
//extern int GetMainLanguageCode (int lang);
//extern int GetAlternativeLanguageCode (int lang);

#define ACTION_DELETE_ENTRY		1
#define ACTION_APPEND_ENTRY		2
#define ACTION_EDIT_ENTRY			3
#define ACTION_ACTIVATE_VIEWER	4
#define ACTION_MOVE_TO_NEXT		5
#define ACTION_COPY_AND_MINIMIZE	6
#define ACTION_TRANSLATE_BACK		7
#define ACTION_TOGGLE_TYPEIN		8

// Types of databases to work with
#define	DICT_TYPE_DICTIONARY		0
#define	DICT_TYPE_SUGGEST			2
#define	DICT_TYPE_TYPEIN			3

extern FILE *fopen (Cbyte &buff, const char *mode);
extern char *strstr (Cbyte &string, const char *strCharSet);
extern char *strstr (Cbyte &string, Cbyte &strCharSet);
extern char *strchr (Cbyte &string, int c);
extern char *fgets (Cbyte &string, int n, FILE *stream);
extern int fputs (Cbyte &string, FILE *stream);
extern int mygolower (Cbyte &buff); /* converts string to lowercase for both alphabets */
extern int	mydelete (Cbyte &name);
extern int	myrename (Cbyte &oldname, Cbyte &newname);
extern int	mycreate (Cbyte &name, Cbyte &ext, int type);
extern int cypher (byte *buff, int size, int code);
extern int cypher (Cbyte &string, int size, int action);
extern int encypher (byte *buff, int size);
extern int encypher (Cbyte &string, int size);
extern int decypher (byte *buff, int size);
extern int decypher (Cbyte &string, int size);
extern unsigned long chsum (Cbyte &s, int n);
extern unsigned long chsum (byte *s, int n);
extern int  myopen (Cbyte name, Cbyte ext, unsigned int type);
extern byte *DosToWinAbc (Cbyte &buff, int size = 0);
extern byte *WinToDosAbc (Cbyte &buff, int size = 0);
extern byte *DosToWinAbc (byte *buff, int size = 0);
extern byte *WinToDosAbc (byte *buff, int size = 0);

//extern Cbyte data.m_datapath;
//extern Cbyte data.m_localpath;

extern int SetDictLine (Cbyte &where, byte *path , byte *name, int num);
extern int GetDictLine (Cbyte &where, Cbyte &path , Cbyte &name, int num);

#define CONTEXT_NUMBER		0
#define LINGVO_NUMBER		1
#define MULTILEX_NUMBER		2
#define POLYGLOSSUM_NUMBER	3

extern long GetDiskFreeSpace (byte *path);

#define ROUND_BRACKETS		0
#define SQUARE_BRACKETS		1
#define ANGLE_BRACKETS		2

extern int SortLines (byte *fname, byte *type, byte *options);
extern int SortByNumberAndString (byte *ifname, byte *ofname);
extern void CreateLocalPath ();
extern bool CreateLocalPath(LPCTSTR lpLocalPath);

#ifndef __BITS64__
#define __BITS64__
#define MAKEINT64(x, y) (((x)&0x00000000FFFFFFFF)|(((y)<<32)&0xFFFFFFFF00000000))
#define MAKEDWORDLONG(x, y) (((x)&0x00000000FFFFFFFF)|(((y)<<32)&0xFFFFFFFF00000000))
#define LODWORD(x) ((DWORD)((x)&0x00000000FFFFFFFF))
#define HIDWORD(x) ((DWORD)(((x)>>32)&0x00000000FFFFFFFF))
#endif


/******************************************************************************/
/*                                                                            */
/* Copyright (c) 1998-2000 L.A.Lyapkov. All rights reserved                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

#if !defined(AFX_SHMALLOC_H__2D21551C_425C_11D2_9E24_8953FC7FB905__INCLUDED_)
#define AFX_SHMALLOC_H__2D21551C_425C_11D2_9E24_8953FC7FB905__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef NO_RPCNDR

#ifdef WIN32
#include <shlobj.h>
#endif

#ifdef WIN32

class ShMalloc  
{
public:
	ShMalloc()
	{
#ifdef WIN32
		if (SHGetMalloc(&m_pMalloc) != NOERROR)
		{
			m_pMalloc = 0;
			_ASSERT(0);
		}
#endif
	}

	~ShMalloc()
	{
		if (m_pMalloc)
			m_pMalloc->Release();
		Free(m_pMalloc);
	}

public:
	void*	Alloc(ULONG cb)
	{
		if (m_pMalloc)
			return m_pMalloc->Alloc(cb);
		return 0;
	}

	void*	Realloc(void* pb, ULONG cb)
	{
		if (m_pMalloc && m_pMalloc->DidAlloc(pb))
			return m_pMalloc->Realloc(pb, cb);
		return 0;
	}

	void	Free(void* pb)
	{
		if (m_pMalloc && m_pMalloc->DidAlloc(pb))
			m_pMalloc->Free(pb);
	}

	BOOL	DidAlloc(void* pb)
	{
		if (m_pMalloc)
			return m_pMalloc->DidAlloc(pb);
		return 0;
	}

protected:
	LPMALLOC m_pMalloc;
};
#endif
#endif

#endif // !defined(AFX_SHMALLOC_H__2D21551C_425C_11D2_9E24_8953FC7FB905__INCLUDED_)



#endif

