/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef __OFUNC_H     /* prevent multiple includes */
#define __OFUNC_H
#include "ohead.h"

extern byte *longtothree (long &var);
extern long  threetolong (byte* var);

extern int	cmpwords   (char *s1, int, char* s2, int len);
#define CHECK_ALL_FORMS 1
#define CHECK_ONE_FORM  2
extern int	hasend (LPCTSTR buff1, LPCTSTR buff2, int type = CHECK_ONE_FORM);
extern void shorten (byte *buff, int size);
extern void ltrim      (byte* s);
extern void rtrim      (byte* s);
extern byte *alltrim    (byte* s);

extern DWORD getmaxmem();
#if 1 // def DEBUG
extern byte *strealloc (byte *buff, DWORD size);
extern byte *stalloc (DWORD size);
extern long getusedmemory();

extern int testblocks (int dowrite = 0);
extern void stfree (void *p);
#else
#define stalloc (byte *)malloc
#define stfree  free
#define strealloc (byte *)realloc
#endif

// useful conversion functions
extern byte *lintochar  (unsigned long var);

// file access functions
extern int mread (int fh, byte *buf, int size);
extern int mwrite (int fh, byte *buf, int size);
extern int mopen (byte *fname, unsigned int type);
extern int mclose (int hand);


extern byte *intochar   (unsigned int var);
extern byte *find_replace (byte *where, byte *what, byte *whatto); // find something in substring and replace

extern int GetLinePart (byte *whereto, byte *wherefrom, int num, byte *delim = " ");
extern int GetMaxLineParts (LPCTSTR whereto, byte *delim = " ");
extern int ReplaceLinePart (byte *wherefrom, int num, byte *delim, byte *whatto); // replace specified element
extern int DeleteLinePart (byte *wherefrom, int i, byte *delim);

// Receives text buffer containing (supposedly) one word and test lgk
// Returns 1 if this word belongs to this part of speech
extern int ShowProgress (long count, int flag = 5); // Shows progress in 1024 increments for cycles (linefunc.cpp)

#endif
