/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef __CSCRIPTFUNC_H     /* prevent multiple includes */
#define __CSCRIPTFUNC_H

#define SCRIPT_APPEND_ENTRY		1
#define SCRIPT_DELETE_ENTRY		2
#define SCRIPT_EDIT_ENTRY			3
#define SCRIPT_APPEND_STEM			4
#define SCRIPT_APPEND_SUBJECT		5
#define MAX_SCRIPT_LINES 20

#include "cbyte.h"

class ScriptFunc
{
public:
	ScriptFunc();

	int	GetMaxEntries ();
	void	CheckStemWords ();
	static const int GetScriptFieldType (Cbyte &buff);
	int	OpenScriptFile (Cbyte &fname);
	int	ReadScriptEntry (long off = -1);
	void	GetEntryDate (Cbyte &buff);
	void	GetEntryUser (Cbyte &buff);
	void	GetEntryTime (Cbyte &buff);
	void	GetEntryContent (Cbyte &buff);
	void	GetActionType (Cbyte &buff);
	void	WriteChanges (long *offsets, int max);
	void	WriteScriptEntry();
	void	GetField (int num, Cbyte &buff);
	int	ImportWriteChanges (long offset);
	void	CheckGluedEntries ();

	int	m_ReplaceExistingEntries;
	FILE *m_ihand;
	FILE *m_ohand;
	Cbyte m_fields[MAX_SCRIPT_LINES + 1];
	long	m_startpos;
	int	m_maxfields;
	int	m_type;
	Cbyte	m_InputFileName;
	int	m_maxsubjects;
	Cbyte m_subjects[2048];
	int	m_TextDos;
};

#endif  // __CSCRIPTFUNC_H
