/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Synthesized abbreviation class

#ifndef __CSABBR_H     /* prevent multiple includes */
#define __CSABBR_H

#include "btree.h"
#include "getbit.h"
#include "noclass.h"
#include "trabuff.h"

class SyntAbbr : public BTree {
public:
   SyntAbbr (int langin, int langout);
	void	ReBuild();
	int	AppendAbbreviationReference (TraBuff &TB);
	int	FormSynthesizedAbbreviation (Cbyte &orig, Cbyte &sabbr);
	int	CountAbbreviationsForSubjects (Cbyte &abbr, Cbyte &out);
	int	GetSubject ();
	int	AddCount (Cbyte &out, int snum, int max);
	int	CollectTermNumbersForSubject (Cbyte &buff, int scode, Cbyte &out);
	int	SearchAbbrAndScode (Cbyte &buff, int scode);
   };
#endif  // __CSABBR_H
