/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

//#ifndef __TRAENTRY_H
#include "traentry.h"
#include "stem.h"
//#endif

#define DUMP_FILE_NAME 	"script.txt"

class TextDump {
public:
	TextDump ();
	TextDump (int langin, int langout, long termnum = 0, int usedump = 0);
	TextDump (TraBuff *TBPtr, int usedump = 0, byte *fname = NULL);
	TextDump (int snum);
	~TextDump();

	void	DumpSubject (int snum);
	void	OpenScriptFile ();
	void	DumpLine (Cbyte line);
	void	CloseDump();
	int	WriteEntry (byte *type);
	int	NewWriteEntry (byte *type);
	void	WriteHeader (byte *type);
	int	DumpStemBlock (Stem *StemPtr, int pos);
	void	InitDump (int langin, int langout, long termnum, int usedump);

	FILE *m_hand;
	byte m_nextline[2];
	TraEntry m_TE;
	TraBuff	*m_TBPtr;
	int	m_UseDump;
	int	m_UseTime;
	Cbyte	m_ScriptFileName;
};
