/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// ???

#ifndef __TRAENTRY_H     /* prevent multiple includes */
#define __TRAENTRY_H

#include "trabuff.h"
#include "cword.h"
#include "index.h"

// parameters for CheckEntryPresence
#define CHECK_THIS_TERM_NUMBER  1
#define CHECK_ANY_TERM_NUMBER   2

// for CompareEntries
#define CHECK_ALL_ENTRIES -1

// For CheckEntryPresence

// array types for FormDumpWordString  
class TraEntry {
public:
	TraEntry (int langin = 0, int langout = 0);
   ~TraEntry();

	void	AutoProcessEntry (int dosettle = 1);
	int	InitTraEntry (int langin, int langout);
	void	CheckEntryPresence (int dir = BOTH_DIRECTIONS, int checkflag = IGNORE_CASE | IGNORE_NOLETTER_SYMBOLS | IGNORE_BRACKETS);
   int	InScript (Cbyte &fname);
   int	DetermineLanguage (Cbyte &buff);
	int	FillOldNums();   // find old index strings for entry before editing
//   int	DeleteEntry (long termnum, int type = BOTH_DIRECTIONS);
//   long	WriteEntry (TraEntry &copyTE, int type = 0);
   int	CollectScriptInformation ();
   int	IsSameWord (Cbyte &form1, Cbyte &form2);
	int	AutoResaveEntry (long termnum);
	void	StoreOldValues ();
	int	CheckAbsoluteEntryPresence ();
	int	CompareEntries (int dir, int pos = -1, int checkflag = IGNORE_CASE | IGNORE_NOLETTER_SYMBOLS | IGNORE_YO);
	int	FindExistingEntry ();
	static const  void	GetSameExplanation (int m_same, Cbyte &buff);

   void operator = (TraEntry &TE);

	// Import
	int	RunInScript (int realimport = 1);
	void	CheckUseFile();
	int	DumpUnknownWords();
	void	InitTextFiles();

   TraBuff m_TB;                // translation buffer class instance
	int	m_SpeechPart;		   	  // used for screen display

	int	m_HiddenDialog;
	long	m_FoundTermNumber;
	long	m_FoundTermNumberWithoutComment;
	int	m_DuplicateIndexReference;
   int	m_same[2];
   int	m_WasSubject;
   int	m_WasSubject1;
   byte	m_oldnums[2][(MAX_PHRASE + 1)*3];       // old index strings before entry editing
   int	m_oldmax[2];
   byte	m_foundnums[2][(MAX_PHRASE + 1)*3];     // storage of word number strings
   int	m_foundmax[2];				// number of words in m_wordnumbers
	int	m_foundpos[2];				// found positions in index
   int	m_AutoUseComments;			// use comments for automatic appending
   int	m_DeleteOldIfTooLong;		// if entry exists but script entry does not contain it's reference in one of the directitons
	long	m_StartTermNumber;
	Index *m_Iptr;

	int	m_SaveDirection;
//	int	m_MaxReverseWords;
//	int	m_UseSubject;
};

#if 0
#define MAXSCRIPTBUFF 10
class InScript : public TraEntry
{
public:
   InScript (char *fname);
   ~InScript();
   ClearBuffers();
   RunInScript (int type = 0);
   DumpBuffers (Cbyte &extension);
   DumpUnknownWords();
   FillEntryFields();
   ConvertWordInfo();
   SameStem();
   DeleteEntry();
   PositionEntry();
   SetBullet();
   PrepareImportData();
   int CheckUseFile();
   int InitTextFiles();
   FILE *OpenText (Cbyte &ext, Cbyte &type);
   int RedoFormat ();
   int IsSpecialEntry ();
   int ExplainExist (Cbyte &buff);
   FILE *m_hand;
   Cbyte m_ImportFileName;
   CWord m_scriptinfo[2];
   int m_GlobalSubject;
   BufferEntry BE;
};
#endif

#define	SAME_ORIGTRANS									1
#define	SAME_SUBJECT									2
#define	SAME_EXTENDS									4
#define	SAME_CUTS										8
#define	SAME_OTHERTRAEXIST							16
#define	SAME_OTHERTRAEXIST1							32
#define	SAME_COMMENT									64
#define	SAME_FORWARD									128  // set only when looking for the same entry !!!
#define	SAME_BACKWARD									256  // use SAME_DIRECTION* for other cases !!!
#define	SAME_DIRECTION1								512
#define	SAME_DIRECTION2								1024
#define	SAME_SUBJECT_FOR_OTHER_TRANSLATION		2048
#define	SAME_INCLUDED									2048*2
#define	SAME_DIFFERENT_COMMENT						2048*4
#define	SAME_ALLFIELDS      (SAME_ORIGTRANS | SAME_COMMENT | SAME_SUBJECT)
#define	SAME_ORIGTRANSCOMMENT      (SAME_ORIGTRANS | SAME_COMMENT)

#define MAXCOINCIDE 10
class CheckTraEntry
{
public:
	CheckTraEntry (TraEntry &Oldentry, TraEntry &NewEntry);
   ~CheckTraEntry();

	void	AssingOldEntry (TraEntry &OldEntry);
	void	AssingNewEntry (TraEntry &NewEntry);
	int	CheckEntryPresence (TraEntry &TEptr);
	int	CompareEntries (TraBuff &TBptr, int dir, int needpos = -1);
	int	Check();
	int	GetTotalCoincide();
	int	AutoSettle();

	TraEntry	m_OldTraEntry;
	TraEntry	m_NewTraEntry;
	int	m_MaxCoincide;
	int	m_AutoResave;

	long	m_termnum[MAXCOINCIDE];
   byte	m_foundnums[MAXCOINCIDE][2][(MAX_PHRASE + 1)*3];     // storage of word number strings
   int	m_foundmax[MAXCOINCIDE][2];				// number of words in m_wordnumbers
	int	m_same[MAXCOINCIDE];

	Index	*m_Iptr;
};

#endif // __TRAENTRY
