/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

// Transcription file

#ifndef __CTRANSCRIPTION_H
#define __CTRANSCRIPTION_H

#include "btree.h"

class Transcription : public BTree
{
public:
	~Transcription ();
	Transcription (int lang = 0);
	int	OpenTranscription (int lang, Cbyte &datapath = data.m_datapath);
	int	SetTranscription (Cbyte &wword, Cbyte &transcr);
	int	DeleteTranscription (Cbyte &wword);
	int	GetTranscription (Cbyte &wword, Cbyte &transcr, int lgk = 0);
	int	CreateFromFile (byte *fname, int lang);
	void	DumpNumbers (void);
	void	Dump (byte *fname = NULL);
	void	GetTranscriptionFromRecord (Cbyte &transcr);
	void	CollectFromStemDictionary (void);
	int	GetCurrentWord (Cbyte &buff);
	static const void ReOpenDatabases (int justclose = 0);

	Cbyte m_CurrentWord;
};

extern Transcription *GetTranscriptionPointer (int lang, Cbyte &datapath = data.m_datapath);
#endif
