/* This file is part of libmt library
   Copyright (C) 2002  Multitran Project <libmt@multitran.ru>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef __TYPEIN_H     /* prevent multiple includes */
#define __TYPEIN_H

#include "btree.h"
#include "trabuff.h"

#define TYPEIN_DELIMITER_SYMBOL	"\x1"
#define TYPEIN_REALWORD_SYMBOL	"\x2"
#define CONVERT_FOR_SEARCH 1

class TypeIn : public BTree
{
public:
	TypeIn (int langint = 0, int langout = 0);
	int	OpenTypeIn (int langin, int langout, Cbyte &datapath = data.m_datapath);
	void	Generate();
//	int	AddRecord (Cbyte &word, int snum);
	int	GetSubject (int i);
	void	Dump();
	void	GetCurrentOriginal (Cbyte &wword, int type = CONVERT_FOR_SEARCH);
	void	GetCurrentSubjectName (Cbyte &wword);
	int	SkipWithSubjectCheck (int dir);
	int	GetMaxSubjects();
	int	CreateTypeInList (int lang1, int lang2);
	int	AppendToTypeInList (TraBuff &TB);
	int	IsActiveLine();
	int	DeleteFromTypeInList (TraBuff &TB);
	int	DeleteSubjectPosition (int elem);
	int	FormTypeInDatabaseLine (Cbyte &buff);
	int	SeekLine (Cbyte &buff, int type);
	int	SkipLine (int direction);
	static const void ReOpenDatabases (int justclose = 0);
};

extern TypeIn *GetTypeInPointer (int lang, int langout, Cbyte &datapath = data.m_datapath);
#endif
